//O[o萔@BA{{f[^邱Ƃł鏊
float4x4 mW;//[hsiL̍sj
float4x4 mV;//r[siJj
float4x4 mP;//ˉei2Djϊs

//֊spf[^[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[
float4 OutlineColor = float4(0, 0, 0, 0);;	//֊sF
float OutlineSize = float(1);		//֊s̑//
//[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[
//}bsOp
//---------------------------------------------------------------------------------------------------------
float RefPower = 0.5;//f荞ݗ
texture CubeTex;
samplerCUBE CubeSmp = sampler_state {
	Texture = <CubeTex>;
	MipFilter = LINEAR;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	AddressU = Wrap;
	AddressV = Wrap;
};
//-----------------------------------------------------------------------------------------------------------
//}eA֌W
//-----------------------------------------------------------------------------------------------------------
float4 MateSpecular = float4(1, 1, 1, 1);		//ːF
float MateSpePower = 50;						//˂̉s
float4 MateDiffuse = float4(1, 1, 1, 1);		//}eAF
texture MateDiffuseTex;							//}eÃeNX`

//MateDiffuseTexpTv
sampler MateDiffuseSmp = sampler_state {
	Texture = <MateDiffuseTex>;
	MipFilter = LINEAR;
	MinFilter = LINEAR; //tB^
	MagFilter = LINEAR;
	AddressU = Wrap;//eNX`@AhVO[h
	AddressV = Wrap;
};
//----------------------------------------------------------------------------------------------------------
//Cg֌W
//--------------------------------------------------------------------------------------------------------
float4 LightColor = float4(1, 1, 1, 1);
float3 LightDir = float3(0, -1, 0);				//s̕
float4 LightAmbient;							//@΂ɓ
float4 LightSpecular = float4(1, 1, 1, 1);		//˂̐F
												//----------------------------------------------------------------------------------------------------------
//J֌W
//--------------------------------------------------------------------------------------------------------
float3 CamPos;								//JW

//_VF[_o͗p\́@@@_VF[_@_W2d
struct VS_OUT {
	float4 Pos		: POSITION;		//ˉeiQjW@Z}eBNX@
	float3 wN       : TEXCOORD0;    //[h@
	float2 MeshUV	: TEXCOORD1;	//UVW
	float3 wPos		: TEXCOORD2;	//3DW

};

//_VF[_
VS_OUT VS(float4 Pos	 :	POSITION,
		  float3 normal  :  NORMAL,		//@xNg
		  float2 mesh_uv :  TEXCOORD0)	//UVW
{
	VS_OUT Out;
	Out.Pos = mul(Pos, mW);			//RD
	Out.wPos = Out.Pos.xyz;
	Out.Pos = mul(Out.Pos, mV);
	Out.Pos = mul(Out.Pos, mP);
	Out.wN = mul(normal, (float3x3)mW);
	Out.wN = normalize(Out.wN);
	Out.MeshUV = mesh_uv;
	return Out;

}
//sNZVF[_o͗p\
struct PS_OUT
{
	float4 Color : COLOR0;  // o͐F(RenderTarget0Ԗڂɏo͂)
};
PS_OUT PS(VS_OUT In)
{
	//@
	float3 w_normal = normalize(In.wN);
	float3 vCam = normalize(CamPos - In.wPos);		//J̕

													//--------------------------------------
													//fF
													//--------------------------------------
	float4 texCol = tex2D(MateDiffuseSmp, In.MeshUV);
	float4 modelCol = MateDiffuse*texCol;

	//--------------------------------------
	//CgF
	//--------------------------------------
	float4 lightCol = float4(0, 0, 0, 1);
	//sCeBOio[gj
	float LPow = dot(-LightDir, w_normal);
	LPow = saturate(LPow);
	//ToonTexF擾
	/*float4 toonCol = tex2D(ToonSmp, float2(LPow, 0));*/
	lightCol += LightColor*LPow;

	//
	lightCol += LightAmbient;

	//ˌ
	float4 lightSpe = 0;
	float3 vRef = reflect(LightDir, w_normal);
	float SPow = dot(vCam, vRef);		//-1~1
	SPow = saturate(SPow);				//0~1
	SPow = pow(SPow, MateSpePower);
	lightSpe += LightSpecular * SPow;

	//--------------------------------------
	//Fo
	//--------------------------------------
	float4 diffuseCol = modelCol * lightCol;//gUF
	float4 speCol = lightSpe * MateSpecular;
	PS_OUT Out;
	Out.Color = diffuseCol;
	Out.Color.rgb += speCol.rgb;
	return Out;

}
//eNjbN
technique Tech {
	pass P0 {
		VertexShader = compile vs_3_0 VS();   // _VF[_VS()g
		PixelShader = compile ps_3_0 PS();    // sNZVF[_PS()g
	}
}
//[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[
//֊sVF[_
//---------------------------------------------------------------------------------
struct OutlineVS_OUT {//_VF[_o͗p\́@
	float4 Pos		: POSITION;//ˉeiQjW@Z}eBNX
};
//vs
OutlineVS_OUT OutlineVS(float4 pos:POSITION, float3 normal : NORMAL) {
	OutlineVS_OUT Outline;
	//pos + e normalɂ炷
	pos.xyz += normal*OutlineSize;//error
	//2D(ˉej
	Outline.Pos = mul(pos, mW);		
	Outline.Pos = mul(Outline.Pos, mV);
	Outline.Pos = mul(Outline.Pos, mP);
	return Outline;
}
//ps
//float4 OutlinePS(OutlineVS_OUT In):COLOR0 {
//	return OutlineColor;
//}
struct OutlinePS_OUT
{
	float4 Color : COLOR0;  // o͐F(RenderTarget0Ԗڂɏo͂)
};
OutlinePS_OUT OutlinePS(OutlineVS_OUT In)
{
	OutlinePS_OUT Outline;
	Outline.Color = OutlineColor;
	return Outline;
}
//eNjbN
technique OutlineTech {
	pass pa {
		VertexShader = compile vs_3_0 OutlineVS();
		PixelShader = compile ps_3_0 OutlinePS();
		CullMode = CW;		//JO[hCWɁiʕ`j
	}
};